import { world, system } from '@minecraft/server';

system.afterEvents.scriptEventReceive.subscribe(async (event) => {
  if (event.id === "fearcube:RadiusDamages") {
    (async () => {
      try {
        const [radiusStr, maxDamageStr] = event.message.split(',').map(str => str.split('=')[1]);
        const radius = parseInt(radiusStr, 10);
        const maxDamage = parseInt(maxDamageStr, 10);
        const entity = event.sourceEntity;
        const { x: sx, y: sy, z: sz } = entity.location;
        let teamC = ""; let teamT = "";

        for (const player of world.getPlayers()) {
          if (player.hasTag('cs:bomb_detonation')) {
            
            if (player.hasTag(`cs:terrorist`)) { teamC = "§c"; teamT = ""; }
            if (player.hasTag(`cs:commando`)) { teamC = ""; teamT = "§9"; }

            const { x: px, y: py, z: pz } = player.location;
            const distance = Math.sqrt((sx - px) ** 2 + (sy - py) ** 2 + (sz - pz) ** 2);

            if (distance <= radius) {
              const damageAmount = maxDamage * (1 - distance / radius);
              const roundedDamageAmount = Math.round(damageAmount);
              player.applyDamage(damageAmount);
              const healthComponent = player.getComponent('minecraft:health');

              if (healthComponent && healthComponent.currentValue <= 0) {
                await world.getDimension('overworld').runCommandAsync(`tellraw @a[tag=cs:game] {"rawtext":[{"text":" ${teamC}${teamT}${player.name} "}]}`);
              } else {
                await world.getDimension('overworld').runCommandAsync(`tellraw @a[tag=cs:game] {"rawtext":[{"text":" ${teamC}${teamT}${player.name}  §c-${roundedDamageAmount}"}]}`);
              }
            }
          }
        }

      } catch (error) {
        await world.getDimension('overworld').runCommandAsync(`tellraw @a {"rawtext":[{"text":"Ошибка при обработке события: ${error.message}"}]}`);
      }
    })();
  }
});
