import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { system, world } from '@minecraft/server';
import { getPlayerTagData, getTagValue } from '../../systemFiles/tagUtils.js';
import { runcmd, runcmd_at, BoolToNum, getScore } from '../../systemFiles/tools';


function formatTime(seconds) {
    let hrs = Math.floor(seconds / 3600);
    let mins = Math.floor((seconds % 3600) / 60);
    let secs = seconds % 60;

    hrs = hrs < 10 ? '0' + hrs : hrs;
    mins = mins < 10 ? '0' + mins : mins;
    secs = secs < 10 ? '0' + secs : secs;

    return `§c${hrs}§6:§c${mins}§6:§c${secs}§r`;
}




system.afterEvents.scriptEventReceive.subscribe((event) => {


    if (event.id === "fearcube:forms",event.message === "cs_select_arens") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
    
        let form = new ActionFormData();
        form.title("%fearcube.cs.name");
        form.body(``);
        form.button(`§l§4№1§r Dust2\n%fearcube.builders: Johncoco12`, "textures/icon/arens/cs_arena1");
        form.button(`§l§4№2§r Inferno\n%fearcube.builders: LesRaisins`, "textures/icon/arens/cs_arena2");
        form.button(`§l§4№3§r Mirage\n%fearcube.builders: DrumbledoresArmy`, "textures/icon/arens/cs_arena3");
        form.button(`§l§4№4§r Train\n%fearcube.builders: CODRE`, "textures/icon/arens/cs_arena4");
        form.button(`§l§4№5§r Nuke\n%fearcube.builders: CODRE & WENDER`, "textures/icon/arens/cs_arena5");

    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'function games/cs/lobby/arens/arena1')
                    break;
                case 1: runcmd_at(name, 'function games/cs/lobby/arens/arena2')
                    break;
                case 2: runcmd_at(name, 'function games/cs/lobby/arens/arena3')
                    break;
                case 3: runcmd_at(name, 'function games/cs/lobby/arens/arena4')
                    break;
                case 4: runcmd_at(name, 'function games/cs/lobby/arens/arena5')
                    break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }


    if (event.id === "fearcube:forms",event.message === "settings_cs_info") {

        let player = event.sourceEntity
        let lobby_timer = getScore("fear:settings","cs.timer_lobby");
        let minimum_players = getScore("fear:settings","cs.minimum_players");

        let friendly_damage = getScore("fear:settings","cs.friendly_damage");
        let grenade_damage_allies = getScore("fear:settings","cs.grenade_damage_allies");

        let procurement_time = getScore("fear:settings","cs.procurement_time");
        let store_validity_time = getScore("fear:settings","cs.store_validity_time");

        let timer_special_win = getScore("fear:settings","cs.timer_special_win");
        let timer_bomb_explodes = getScore("fear:settings","cs.timer_bomb_explodes");

        let number_money_first_round = getScore("fear:settings","cs.number_money_first_round");
        let number_rounds_win_game = getScore("fear:settings","cs.number_rounds_win_game");

        let C = "";let C1 = "";

        if (friendly_damage >= 1) {C = "%fearcube.included";} else {C = "%fearcube.turned_off";}
        if (grenade_damage_allies >= 1) {C1 = "%fearcube.included";} else {C1 = "%fearcube.turned_off";}

        let form = new ActionFormData();
        form.body(`\n §l%fearcube.hns.setting.game %fearcube.cs.name §r\n\n\n§l%fearcube.setting_lobby§r:§r\n §7 %fearcube.hns.setting.tume_lobby: §a${lobby_timer}§r\n §7%fearcube.hns.setting.players: §a${minimum_players}\n\n\n\n§r§l%fearcube.hns.setting.game§r:§r\n\n §7 %fearcube.cs.setting.procurement_time: §a${procurement_time / 20}§r\n\n §7 %fearcube.cs.setting.store_validity_time: §a${store_validity_time / 20}§r\n\n §7 %fearcube.cs.setting.friendly_damage1: §a${C}§r\n\n §7 %fearcube.cs.setting.grenade_damage_allies1: §a${C1}§r\n\n §7 %fearcube.cs.setting.timer_special_win: §a${timer_special_win / 20} §r\n\n §7 %fearcube.cs.setting.timer_bomb_explodes: §a${timer_bomb_explodes / 20}§r\n\n §7 %fearcube.cs.setting.number_money_first_round: §a${number_money_first_round}§r\n\n §7 %fearcube.cs.setting.number_rounds_win_game: §a${number_rounds_win_game}\n\n§r `);
        form.button("%dr.button.ok ");

        form.show(player).then(r => {}).catch((e) => {
            console.error(e, e.stack);
        });
    
    }




    if (event.id === "fearcube:forms",event.message === "settings_cs") {

        let player = event.sourceEntity
        let lobby_timer = getScore("fear:settings","cs.timer_lobby");
        let minimum_players = getScore("fear:settings","cs.minimum_players");

        let friendly_damage = getScore("fear:settings","cs.friendly_damage");
        let friendly_damage1 = Boolean(friendly_damage);
        let grenade_damage_allies = getScore("fear:settings","cs.grenade_damage_allies");
        let grenade_damage_allies1 = Boolean(grenade_damage_allies);

        let procurement_time = getScore("fear:settings","cs.procurement_time");
        let store_validity_time = getScore("fear:settings","cs.store_validity_time");

        let timer_special_win = getScore("fear:settings","cs.timer_special_win");
        let timer_bomb_explodes = getScore("fear:settings","cs.timer_bomb_explodes");

        let number_money_first_round = getScore("fear:settings","cs.number_money_first_round");
        let number_rounds_win_game = getScore("fear:settings","cs.number_rounds_win_game");

        let form = new ModalFormData()
        form.title("%options.editSettings");

        // lobby
        form.slider("\n\n§l%fearcube.setting_lobby§r:\n %fearcube.hns.setting.tume_lobby §a", 10, 60, 10, lobby_timer )
        form.slider("%fearcube.hns.setting.players §a", 1, 15, 1, minimum_players )

        // Game
        form.slider("\n\n\n\n§l%fearcube.hns.setting.game§r:\n %fearcube.cs.setting.procurement_time §6", 10, 40, 1, procurement_time / 20 )
        form.slider(" %fearcube.cs.setting.store_validity_time §6", 10, 60, 1, store_validity_time / 20 )

        form.toggle(" %fearcube.cs.setting.friendly_damage1", friendly_damage1)
        form.toggle(" %fearcube.cs.setting.grenade_damage_allies1", grenade_damage_allies1)  

        form.slider(" %fearcube.cs.setting.timer_special_win §a", 20, 120, 1, timer_special_win / 20 )
        form.slider(" %fearcube.cs.setting.timer_bomb_explodes §a", 20, 120, 1, timer_bomb_explodes / 20 )
        
        form.slider(" %fearcube.cs.setting.number_money_first_round §a", 500, 5000, 100, number_money_first_round )
        form.slider(" %fearcube.cs.setting.number_rounds_win_game §a", 1, 15, 1, number_rounds_win_game )

        form.show(player).then(r => {
            if (r.canceled) return;
            let [ slider1, slider2, slider3, slider4, toggle1, toggle2, slider5, slider6, slider7, slider8 ] = r.formValues;

            runcmd(`scoreboard players set cs.timer_lobby fear:settings ${slider1}`)
            runcmd(`scoreboard players set cs.minimum_players fear:settings ${slider2}`)
            runcmd(`scoreboard players set cs.procurement_time fear:settings ${slider3 * 20}`)
            runcmd(`scoreboard players set cs.store_validity_time fear:settings ${slider4 * 20}`)
            runcmd(`scoreboard players set cs.timer_special_win fear:settings ${slider5 * 20}`)
            runcmd(`scoreboard players set cs.timer_bomb_explodes fear:settings ${slider6 * 20}`)
            runcmd(`scoreboard players set cs.number_money_first_round fear:settings ${slider7}`)
            runcmd(`scoreboard players set cs.number_rounds_win_game fear:settings ${slider8}`)
            runcmd(`scoreboard players set cs.friendly_damage fear:settings ${BoolToNum(toggle1)}`)
            runcmd(`scoreboard players set cs.grenade_damage_allies fear:settings ${BoolToNum(toggle2)}`)
        }).catch(e => {
            console.error(e, e.stack);
        });    
    }

    if (event.id === "fearcube:forms",event.message === "cs_lobby_settings") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
    
        let form = new ActionFormData();
        form.title("%fearcube.cs.name");
        form.body(``);
        form.button(`%fearcube.tune`, "textures/icon/reset");
        form.button(`%options.editSettings`, "textures/icon/change_settings");
        form.button(`%fearcube.tune1`, "textures/icon/view_settings");
        form.button(`%onlinePlay.Back`, "textures/icon/back");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'execute as @s[tag=lobby] at @s run function games/cs/settings/reset')
                    break;
                case 1: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms settings_cs')
                    break;
                case 2: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms settings_cs_info')
                    break;
                case 3: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms cs_lobby')
                   break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }

    if (event.id === "fearcube:forms",event.message === "cs_select_tag") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
        const cs_terrorist = getScore('fear_operation','cs_check_players_terrorist',true)
        const cs_commando = getScore('fear_operation','cs_check_players_commando',true)
    
        let form = new ActionFormData();
        form.title("%fearcube.cs.name");
        form.body(` `);
        form.button(`§l§4%fearcube.cs.terrorist§r\n %fearcube.number_players: ${cs_terrorist}`, "textures/icon/cs/terrorist");
        form.button(`§l§1%fearcube.cs.commando§r\n %fearcube.number_players: ${cs_commando}`, "textures/icon/cs/commando");
    
        form.show(player).then(r => {
            if (r.canceled) return;
        
            let response = r.selection;
            switch (response) {
                case 0:
                    runcmd_at(name, 'function games/cs/lobby/select_team/terrorist')
                    break;
        
                case 1:
                    runcmd_at(name, 'function games/cs/lobby/select_team/commando')
                    break;
    
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    
        }
        if (event.id === "fearcube:forms",event.message === "cs_lobby") {
            let player = event.sourceEntity
            let name = event.sourceEntity.name  
        
            let form = new ActionFormData();
            form.title("%fearcube.cs.name");
            form.body(``);
            form.button(`%playscreen.header.local`, "textures/icon/sword");
            form.button(`%store.promo.details`, "textures/items/map_information");
        
            form.show(player).then(r => {
                if (r.canceled) return;
                let response = r.selection;
                switch (response) {
                    case 0: runcmd_at(name, 'execute as @s[tag=lobby] at @s run function games/cs/lobby/to_lobby')
                        break;
                    case 1: 
                    runcmd_at(name, 'execute as @s[tag=lobby,tag=admin] at @s run scriptevent fearcube:forms cs_lobby_settings')
                    runcmd_at(name, 'execute as @s[tag=lobby,tag=!admin] at @s run scriptevent fearcube:forms settings_cs_info')
                        break;
                    default:
                }
            }).catch(e => {
                console.error(e, e.stack);
            });
        
            }

        if (event.id === "fearcube:forms",event.message === "cs_drop_bomb") {
            let player = event.sourceEntity
        
            let form1 = new MessageFormData();
            form1.title(" ");
            form1.body("%fearcube.cs.bomb_want_leave");
            form1.button1("%createWorldScreen.clearPlayerData.cancel");
            form1.button2("%authentication.store.confirm.button");
            form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
             return }
             player.runCommandAsync(`function items/cs_bomb_item`);
            
            }).catch((e) => { console.error(e, e.stack); });
        
        }


        if (event.id === "fearcube:forms",event.message === "cs_shoop_main") {
            let player = event.sourceEntity
            let name = event.sourceEntity.name

            let objectiveBalance = world.scoreboard.getObjective("cs:balance");
            const scoreBalance = objectiveBalance.getScore(player) ?? 0;
        
            let form = new ActionFormData();
            form.title(`%fearcube.cs.name SHOOP`);
            form.body(`§7%fearcube.balance: §l§a${scoreBalance}$`);
            form.button(`%howtoplay.weapons`, "textures/icon/cs/weapons");
            form.button(`%fearcube.cs.equipment`, "textures/icon/cs/equipment");       
            form.show(player).then(r => {
                if (r.canceled) return;
                let response = r.selection;
                switch (response) {
                    case 0: runcmd_at(name, 'scriptevent fearcube:forms cs_shoop_weapons')
                        break;
                    case 1: runcmd_at(name, 'scriptevent fearcube:forms cs_shoop_equipmen')
                        break;
                    default:
                }
            }).catch(e => {
                console.error(e, e.stack);
            });
        
        }


        if (event.id === "fearcube:forms",event.message === "cs_shoop_weapons") {
            let player = event.sourceEntity
            let name = event.sourceEntity.name
            let objectiveBalance = world.scoreboard.getObjective("cs:balance");
            const scoreBalance = objectiveBalance.getScore(player) ?? 0;
            let purchasedM22;
            if (scoreBalance >= 200) { purchasedM22 = "§2"; } else { purchasedM22 = "§4";}
            let purchasedRVL34;
            if (scoreBalance >= 700) { purchasedRVL34 = "§2"; } else { purchasedRVL34 = "§4";}
            let purchasedPP42;
            if (scoreBalance >= 1250) { purchasedPP42 = "§2"; } else { purchasedPP42 = "§4";}
            let purchasedMN35;
            if (scoreBalance >= 1900) { purchasedMN35 = "§2"; } else { purchasedMN35 = "§4";}
            let purchasedDBN;
            if (scoreBalance >= 2200) { purchasedDBN = "§2"; } else { purchasedDBN = "§4";}
            let purchasedVec35;
            if (scoreBalance >= 1500) { purchasedVec35 = "§2"; } else { purchasedVec35 = "§4";}
            let purchasedACW;
            if (scoreBalance >= 1800) { purchasedACW = "§2"; } else { purchasedACW = "§4";}
            let purchasedAK37;
            if (scoreBalance >= 2700) { purchasedAK37 = "§2"; } else { purchasedAK37 = "§4";}
            let purchasedMDXR;
            if (scoreBalance >= 2100) { purchasedMDXR = "§2"; } else { purchasedMDXR = "§4";}
            let purchasedM42;
            if (scoreBalance >= 3000) { purchasedM42 = "§2"; } else { purchasedM42 = "§4";}
            let purchasedRPK37;
            if (scoreBalance >= 4000) { purchasedRPK37 = "§2"; } else { purchasedRPK37 = "§4";}

            let form = new ActionFormData();
            form.title(`%fearcube.cs.name SHOOP`);
            form.body(`§7%fearcube.balance: §l§a${scoreBalance}$`);
            form.button(`%controller.buttonTip.back`, "textures/icon/back");      
            form.button(`M22 \n${purchasedM22}200$`, "textures/gun_icon/m22"); 
            form.button(`RVL34\n${purchasedRVL34}700$`, "textures/gun_icon/rvl34");
            form.button(`PP42\n${purchasedPP42}1250$`, "textures/gun_icon/pp42");
            form.button(`MN5\n${purchasedMN35}1900$`, "textures/gun_icon/mn5");
            form.button(`DBN\n${purchasedDBN}2200$`, "textures/gun_icon/dbn"); 
            form.button(`Vec35\n${purchasedVec35}1500$`, "textures/gun_icon/vec35");
            form.button(`ACW\n${purchasedACW}1800$`, "textures/gun_icon/acw");
            form.button(`AK37\n${purchasedAK37}2700$`, "textures/gun_icon/ak37");
            form.button(`MDXR\n${purchasedMDXR}2100$`, "textures/gun_icon/mdxr");
            form.button(`M42\n${purchasedM42}3000$`, "textures/gun_icon/m42");
            form.button(`RPK37\n${purchasedRPK37}4000$`, "textures/gun_icon/rpk37");
            form.show(player).then(r => {
                if (r.canceled) return;
            
                let response = r.selection;
                switch (response) {
                    case 0: runcmd_at(name,'scriptevent fearcube:forms cs_shoop_main')
                    break;
                    case 1: runcmd_at(name,'function games/cs/game/shoop/m22')
                        break;
                    case 2: runcmd_at(name, 'function games/cs/game/shoop/rvl34')
                        break;
                    case 3: runcmd_at(name, 'function games/cs/game/shoop/pp42')
                        break;
                    case 4: runcmd_at(name, 'function games/cs/game/shoop/mn5')
                        break;
                    case 5: runcmd_at(name, 'function games/cs/game/shoop/dbn')
                        break;
                    case 6: runcmd_at(name, 'function games/cs/game/shoop/vec35')
                        break;
                    case 7: runcmd_at(name, 'function games/cs/game/shoop/acw')
                        break;
                    case 8: runcmd_at(name, 'function games/cs/game/shoop/ak37')
                        break;
                    case 9: runcmd_at(name, 'function games/cs/game/shoop/mdxr')
                        break;
                    case 10: runcmd_at(name, 'function games/cs/game/shoop/m42')
                        break;
                    case 11: runcmd_at(name, 'function games/cs/game/shoop/rpk37')
                        break;
                    default:}
            }).catch(e => {
                console.error(e, e.stack);
            });
        
        }
        if (event.id === "fearcube:forms",event.message === "cs_shoop_equipmen") {
            let player = event.sourceEntity;
            let name = event.sourceEntity.name;
            
            let objectiveBalance = world.scoreboard.getObjective("cs:balance");
            const scoreBalance = objectiveBalance.getScore(player) ?? 0;
            
            let he_grenade = scoreBalance > 300 ? "§2" : "§4";
            let smoke_grenade = scoreBalance > 300 ? "§2" : "§4";
            let fire_grenade_commando = scoreBalance > 500 ? "§2" : "§4";
            let fire_grenade_terrorist = scoreBalance > 400 ? "§2" : "§4";
            let flash_grenade = scoreBalance > 200 ? "§2" : "§4";     
            let sapper_kit = scoreBalance > 400 ? "§2" : "§4";         
            let form = new ActionFormData();
            form.title(`%fearcube.cs.name SHOOP`);
            form.button(`%controller.buttonTip.back`, "textures/icon/back");     
            form.body(`§7%fearcube.balance: §l§a${scoreBalance}$`);      
            form.button(`%fearcube.cs.he_grenade \n${he_grenade}300$`, "textures/gun_icon/he_grenade"); 
            form.button(`%fearcube.cs.smoke_grenade \n${smoke_grenade}300$`, "textures/gun_icon/smoke_grenade"); 
            
            if (player.hasTag("cs:commando")) {
             form.button(`%fearcube.cs.fire_grenade \n${fire_grenade_commando}500$`, "textures/gun_icon/fire_grenade"); }   
            if (player.hasTag("cs:terrorist")) {
             form.button(`%fearcube.cs.fire_grenade \n${fire_grenade_terrorist}400$`, "textures/gun_icon/fire_grenade"); }
             form.button(`%fearcube.cs.flash_grenade \n${flash_grenade}200$`, "textures/gun_icon/flash_grenade"); 
             if (player.hasTag("cs:commando")) {
                form.button(`%fearcube.cs.sapper_kit \n${sapper_kit}400$`, "textures/items/sapper_kit"); }  
            
             form.show(player).then(r => {
                if (r.canceled) return;
            
                let response = r.selection;
                switch (response) {
                    case 0: runcmd_at(name,'scriptevent fearcube:forms cs_shoop_main')
                    break;
                    case 1:
                        runcmd_at(name, 'function games/cs/game/shoop/grenates/he_grenade');
                        break;
                    case 2:
                        runcmd_at(name, 'function games/cs/game/shoop/grenates/smoke_grenade');
                        break;
                    case 3:
                        if (player.hasTag("cs:commando")) {
                            runcmd_at(name, 'function games/cs/game/shoop/grenates/fire_grenade_commando');

                        } else if (player.hasTag("cs:terrorist")) {
                            runcmd_at(name, 'function games/cs/game/shoop/grenates/fire_grenade_terrorist');
                        }
                        break;
                    case 4:
                        runcmd_at(name, 'function games/cs/game/shoop/grenates/flash_grenade');
                        break;

                    case 5:
                        if (player.hasTag("cs:commando")) {
                            runcmd_at(name, 'function games/cs/game/shoop/grenates/sapper_kit');
                        } 
                        break;
                    default:
                        break;
                }
            }).catch(e => {
                console.error(e, e.stack);
            });
            
        
        }

        if (event.id === "fearcube:forms",event.message === "cs_over_stats") {
            let player = event.sourceEntity
            let name = event.sourceEntity.name

            const totalKills  = getTagValue(player, "c1");
            const temsKills  = getTagValue(player, "c8");
            const KniteKills  = getTagValue(player, "c9");

            const totalDeath  = getTagValue(player, "c2");
            const teamDeath  = getTagValue(player, "c11");

            const timeGame  = getTagValue(player, "c12");
            const totalraunds  = getTagValue(player, "c13");

            const bombP  = getTagValue(player, "c14");
            const bombD  = getTagValue(player, "c15");

            const usedGrenade  = getTagValue(player, "c4");
            const moneySpent  = getTagValue(player, "c3");


            let totalKills1 = totalKills >= 0 ? `\n\n§r %fearcube.cs.over_stats.totalKills - §a${totalKills} ` : '';
            let temsKills1 = temsKills > 0 ? `\n§r %fearcube.cs.over_stats.temsKills - §a${temsKills} ` : '';
            let KniteKills1 = KniteKills > 0 ? `\n§r %fearcube.cs.over_stats.KniteKills - §a${KniteKills} ` : '';

            let totalDeath1 = totalDeath >= 0 ? `\n\n§r %fearcube.cs.over_stats.totalDeath - §c${totalDeath} ` : '';
            let teamDeath1 = teamDeath > 0 ? `\n§r %fearcube.cs.over_stats.teamDeath - §c${teamDeath} ` : '';

            let formattedTime = formatTime(timeGame);
            let timeGame1 = `\n\n§r %fearcube.cs.over_stats.formattedTime §a${formattedTime} `;
            let totalraunds1 = totalraunds >= 0 ? `\n§r %fearcube.cs.over_stats.totalraunds - §a${totalraunds} ` : '';

            let usedGrenade1 = usedGrenade > 0 ? `\n\n§r %fearcube.cs.over_stats.usedGrenade - §a${usedGrenade} ` : '';
            let moneySpent1 = moneySpent > 0 ? `\n§r %fearcube.cs.over_stats.moneySpent: §c-${moneySpent}$ ` : '';

            let bombP1 = bombP > 0 ? `\n\n§r %fearcube.cs.over_stats.bombP - §a${bombP} ` : '';
            let bombD1 = bombD > 0 ? `\n§r %fearcube.cs.over_stats.bombD - §a${bombD} ` : '';
        
            let form = new ActionFormData();
            form.title(`%fearcube.cs.name STATS`);
            form.body(`§l %fearcube.cs.over_stats.game: ${totalKills1}${temsKills1}${KniteKills1}${totalDeath1}${teamDeath1}${timeGame1}${totalraunds1}${usedGrenade1}${moneySpent1}${bombP1}${bombD1}`);
            form.button(`OK`);   
            
            
            form.show(player).then(r => {
                if (r.canceled) return;
                let response = r.selection;
                switch (response) {
                    case 0: 
                        break;
                    default:
                }
            }).catch(e => {
                console.error(e, e.stack);
            });
            // runcmd_at(name, `execute as @a[tag=cs:over_title] at @s run function games/cs/remove_customtags`);
        }
});