import {
  world,
  system
} from '@minecraft/server';


system.afterEvents.scriptEventReceive.subscribe(async (event) => {
    if (event.id === "fearcube:damage") {
        const damageAmount = parseInt(event.message);
        const name = event.sourceEntity.name;
        const player = event.sourceEntity;
    
        let teamC = "";
        let teamT = "";
        let team1C = "";
        let team1T = "";
        let playerHasTerroristTag = false;
        let playerHasCommandoTag = false;
        let protection = "1";
      
        if (player.hasTag(`cs:terrorist`)) {
            teamC = "§c";
            playerHasTerroristTag = player.hasTag('cs:terrorist_grenade_damage');
        }
        if (player.hasTag(`cs:commando`)) {
            teamT = "§9";
            playerHasCommandoTag = player.hasTag('cs:commando_grenade_damage');
        }
    
        for (const targetPlayer of world.getPlayers()) {
            if (targetPlayer.hasTag('fear:damage')) {
                const targetHasTerroristTag = targetPlayer.hasTag('cs:terrorist_grenade_damage');
                const targetHasCommandoTag = targetPlayer.hasTag('cs:commando_grenade_damage');
    
                if ((playerHasTerroristTag && targetHasTerroristTag) || (playerHasCommandoTag && targetHasCommandoTag)) {
                    continue;
                }
    
                if (player.name === targetPlayer.name) {
                    protection = "0"; // Устанавливаем защиту в 0, чтобы не применялся штраф за самоубийство
                } else if (player.hasTag("cs:commando") && targetPlayer.hasTag("cs:commando")) {
                    protection = "2";
                } else if (player.hasTag("cs:terrorist") && targetPlayer.hasTag("cs:terrorist")) {
                    protection = "2";
                }
    
                targetPlayer.applyDamage(damageAmount);
                const healthComponent = targetPlayer.getComponent('minecraft:health');
    
                if (targetPlayer.hasTag("cs:terrorist")) {
                    team1C = "§c";
                }
                if (targetPlayer.hasTag("cs:commando")) {
                    team1T = "§9";
                }
    
                if (healthComponent && healthComponent.currentValue <= 0) {
                    await world.getDimension('overworld').runCommandAsync(`tellraw @a[tag=cs:game] {"rawtext":[{"text":"${teamC}${teamT}${name}  ${team1C}${team1T}${targetPlayer.name}"}]}`);
                    await targetPlayer.runCommandAsync(`tag @s add fear:message_pause`);
                    await player.runCommandAsync(`scriptevent fearcube:add_tag c1=1`);
                    await player.runCommandAsync(`scoreboard players add @s cs:kills_gun 1`);
                    await player.runCommandAsync(`tag @s add fear:stop_murder`);
    
                    if (protection === "1") {
                        await player.runCommandAsync(`execute as "${name}" at @s run tellraw @s {"rawtext":[{"text":" +300$"},{"text":"§2 "},{"translate":"fearcube.cs.kills_gun"}]}`);
                        await player.runCommandAsync(`execute as "${name}" at @s run scoreboard players add @s cs:balance 300`);
                    } else if (protection === "2") {
                        await player.runCommandAsync(`execute as "${name}" at @s run tellraw @s {"rawtext":[{"text":" -300$"},{"text":"§c "},{"translate":"fearcube.cs.teammate_kill_penalty"}]}`);
                        await player.runCommandAsync(`execute as "${name}" at @s run scoreboard players remove @s cs:balance 300`);
                    }
                }
            }
        }
    }
    



  if (event.id === "fearcube:other" && event.message === "cs_set_name_grenade") {
      const entity = event.sourceEntity;
      for (const player of world.getPlayers()) {
          if (player.hasTag('cs:on_grenade')) {
              await entity.runCommandAsync(`tag @s add "${player.name}"`)
              await entity.runCommandAsync(`tag @s add cs:grenade`)
              await entity.runCommandAsync(`tag @a remove cs:on_grenade`)
          }
      }
  }



  if (event.id === "fearcube:other" && event.message === "cs_grenade_damage") {
      const entity = event.sourceEntity;
      const entityTags = entity.getTags();
      for (const player of world.getPlayers()) {
          const playerName = player.name;
          if (entityTags.includes(playerName) && entityTags.includes('fire_grenade')) {
              try {
                  await player.runCommandAsync(`execute as "${playerName}" at @s run scriptevent fearcube:damage 4`);
              } catch (error) {}
          }
      }
  }


  if (event.id === "fearcube:damageRadius") {
    (async () => {
        try {
            const [radiusStr, maxDamageStr] = event.message.split(',').map(str => str.split('=')[1]);
            const radius = parseInt(radiusStr, 10);
            const maxDamage = parseInt(maxDamageStr, 10);
            const entity = event.sourceEntity;
            const { x: sx, y: sy, z: sz } = entity.location;

            let playerEx, playerE;
            let teamC = "", teamT = "", team1C = "", team1T = "";
            let playerExHasTerroristTag = false, playerExHasCommandoTag = false;

            for (const playerExecute of world.getPlayers()) {
                if (playerExecute.hasTag(`cs:he_grenade_${playerExecute.name}`)) {
                    playerEx = playerExecute.name;
                    playerE = playerExecute;

                    if (playerExecute.hasTag("cs:terrorist")) {
                        teamC = "§c";
                        playerExHasTerroristTag = true;
                    }
                    if (playerExecute.hasTag("cs:commando")) {
                        teamT = "§9";
                        playerExHasCommandoTag = true;
                    }
                    break;
                }
            }

            let playerFound = false;
            const processedPlayers = new Set();

            for (const player of world.getPlayers()) {
                if (!processedPlayers.has(player.name) && player.hasTag('fear:damageR') && !player.hasTag('fear:he_grenade_pause_damage')) {
                    const playerHasTerroristTag = player.hasTag('cs:terrorist');
                    const playerHasCommandoTag = player.hasTag('cs:commando');

                    let protection = (playerExHasTerroristTag && playerHasTerroristTag) || (playerExHasCommandoTag && playerHasCommandoTag) ? "2" : "1";

                    if (playerEx === player.name) {
                        protection = "0"; // Устанавливаем защиту в 0, чтобы не применялся штраф за самоубийство
                    } else if (playerExHasTerroristTag && playerHasTerroristTag) {
                        team1C = "§c";
                        team1T = "";
                    } else if (playerExHasCommandoTag && playerHasCommandoTag) {
                        team1C = "";
                        team1T = "§9";
                    } else {
                        team1C = playerHasTerroristTag ? "§c" : "";
                        team1T = playerHasCommandoTag ? "§9" : "";
                    }

                    const { x: px, y: py, z: pz } = player.location;
                    const distance = Math.sqrt((sx - px) ** 2 + (sy - py) ** 2 + (sz - pz) ** 2);

                    if (distance <= radius) {
                        playerFound = true;
                        const damageAmount = maxDamage * (1 - distance / radius);
                        const roundedDamageAmount = Math.round(damageAmount);
                        player.applyDamage(damageAmount);
                        const healthComponent = player.getComponent('minecraft:health');

                        if (healthComponent && healthComponent.currentValue <= 0) {
                            await player.runCommandAsync(`execute as "${playerEx}" at @s run tag @s add fear:stop_murder`);
                            await player.runCommandAsync(`execute as @s[tag=!fear:he_grenade_pause_damage] run tellraw @a[tag=cs:game,tag=!cs:lobby] {"rawtext":[{"text":"${teamC}${teamT}${playerEx}  ${team1C}${team1T}${player.name}"}]}`);
                            await player.runCommandAsync(`execute as "${playerEx}" at @s run scriptevent fearcube:add_tag c1=1`);
                            await player.runCommandAsync(`execute as "${playerEx}" at @s run scoreboard players add @s cs:kills_gun 1`);

                            if (protection === "1") {
                                await player.runCommandAsync(`execute as "${playerEx}" at @s run tellraw @s {"rawtext":[{"text":" +300$"},{"text":"§2 "},{"translate":"fearcube.cs.kills_gun"}]}`);
                                await player.runCommandAsync(`execute as "${playerEx}" at @s run scoreboard players add @s cs:balance 300`);
                            } else if (protection === "2") {
                                await player.runCommandAsync(`execute as "${playerEx}" at @s run tellraw @s {"rawtext":[{"text":" -300$"},{"text":"§c "},{"translate":"fearcube.cs.teammate_kill_penalty"}]}`);
                                await player.runCommandAsync(`execute as "${playerEx}" at @s run scoreboard players remove @s cs:balance 300`);
                            }
                        }

                        await player.runCommandAsync(`tag @s add fear:he_grenade_pause_damage`);
                        await world.getDimension('overworld').runCommandAsync(`event entity @e[type=addon:he_grenade,tag="${playerEx}"] addon:despawning`);
                        processedPlayers.add(player.name);
                    }
                }
            }

            if (!playerFound) {
                await world.getDimension('overworld').runCommandAsync(`event entity @e[type=addon:he_grenade,tag="${playerEx}"] addon:despawning`);
            }

            await world.getDimension('overworld').runCommandAsync(`tag @a remove "cs:he_grenade_${playerEx}"`);
        } catch (error) {
            await world.getDimension('overworld').runCommandAsync(`tellraw @a {"rawtext":[{"text":"Ошибка при обработке события: ${error.message}"}]}`);
        }
    })();
   }





  if (event.id === "fearcube:other" && event.message === "cs_set_name_he_grenade") {
      const entity = event.sourceEntity;
      for (const player of world.getPlayers()) {
          if (player.hasTag('cs:on_grenade')) {

              await player.runCommandAsync(`tag @s add "cs:he_grenade_${player.name}"`)
              await entity.runCommandAsync(`tag @s add "${player.name}"`)
              await entity.runCommandAsync(`tag @s add cs:he_grenade`)
              await entity.runCommandAsync(`tag @a remove cs:on_grenade`)
          }
      }
  }

});