import { world } from '@minecraft/server';

// Подписываемся на событие entityHurt
world.afterEvents.entityHurt.subscribe(eventData => {
    const hurtEntity = eventData.hurtEntity;
    const attacker = eventData.damageSource.damagingEntity;

    // Проверяем, является ли hurtEntity игроком
    if (hurtEntity && hurtEntity.typeId === 'minecraft:player') {
        if (attacker && hasTag(attacker, "cs:game")) {
            playSound(hurtEntity, "fear.cs_hurt");
        } else {
            playSound(hurtEntity, "fear.hurt");
        }
    }
});

function hasTag(entity, tag) {
    return entity.getTags().includes(tag);
}

function playSound(entity, sound) {
    if (!entity || !entity.location) {
        console.error(`Entity or entity location is undefined for entity: ${entity}`);
        return;
    }

    const position = entity.location;
    world.getDimension('overworld').runCommandAsync(`playsound ${sound} @a[tag=!mm:game,tag=!mm:lobby] ${position.x} ${position.y} ${position.z}`)
        .catch(error => console.error(`Failed to play sound: ${error}`));
}
