import { world, system } from '@minecraft/server';

system.afterEvents.scriptEventReceive.subscribe(async (event) => {
  if (event.id === "fearcube:RadiusDamagesSheep") {
    (async () => {
      try {
        const [radiusStr, maxDamageStr] = event.message.split(',').map(str => str.split('=')[1]);
        const radius = parseInt(radiusStr, 10);
        const maxDamage = parseInt(maxDamageStr, 10);
        const entity = event.sourceEntity;
        const playerEx = event.sourceEntity.name
        const { x: sx, y: sy, z: sz } = entity.location;



        for (const player of world.getPlayers()) {
          if (player.hasTag('hns.mobs.boom_damage')) {

            const { x: px, y: py, z: pz } = player.location;
            const distance = Math.sqrt((sx - px) ** 2 + (sy - py) ** 2 + (sz - pz) ** 2);

            if (distance <= radius) {
              const damageAmount = maxDamage * (1 - distance / radius);
              const roundedDamageAmount = Math.round(damageAmount);
              player.applyDamage(damageAmount);
              const healthComponent = player.getComponent('minecraft:health');

              if (healthComponent && healthComponent.currentValue <= 0) {
                await world.getDimension('overworld').runCommandAsync(`execute as "${playerEx}" at @s run tag @s add fear:stop_murder`);
                await world.getDimension('overworld').runCommandAsync(`tellraw @a[tag=hns.mobs] {"rawtext":[{"text":"§a ${playerEx}  §c${player.name} "}]}`);
              } else {
                await world.getDimension('overworld').runCommandAsync(`tellraw @a[tag=hns.mobs] {"rawtext":[{"text":"§a ${playerEx}  §c${player.name} -${roundedDamageAmount}"}]}`);
              }
            }
            await world.getDimension('overworld').runCommandAsync(`tag @a remove hns.mobs.boom`);   
          }
        }

      } catch (error) {
        await world.getDimension('overworld').runCommandAsync(`tellraw @a {"rawtext":[{"text":"Ошибка при обработке события: ${error.message}"}]}`);
      }
    })();
  }
});




