import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { system, world } from '@minecraft/server';
import { runcmd, runcmd_at, BoolToNum, getScore } from '../../systemFiles/tools';




system.afterEvents.scriptEventReceive.subscribe((event) => {



if (event.id === "fearcube:forms",event.message === "hns_lobby") {
    let player = event.sourceEntity
    let name = event.sourceEntity.name  

    let form = new ActionFormData();
    form.title("%fearcube.hns.name");
    form.body(``);
    form.button(`%playscreen.header.local`, "textures/icon/sword");
    form.button(`%store.promo.details`, "textures/items/map_information");

    form.show(player).then(r => {
        if (r.canceled) return;
    
        let response = r.selection;
        switch (response) {
            case 0:
                runcmd_at(name, 'execute as @s[tag=lobby] at @s run function games/hns_mobs/lobby/to_lobby')
                // runcmd_at(name, 'playsound block.end_portal_frame.fill @s ~~~ 1 1')
                break;
    
            case 1:
                runcmd_at(name, 'execute as @s[tag=lobby] at @s run function setting_rights/hns_mobs')
                break;

            default:
        }
    }).catch(e => {
        console.error(e, e.stack);
    });
}

// НАСТРОЙКИ HNS
    if (event.id === "fearcube:forms",event.message === "settings_hns.mobs") {

        let player = event.sourceEntity
        let lobby_timer = getScore("fear:settings","hns.mobs.timer_lobby");
        let minimum_players = getScore("fear:settings","hns.mobs.minimum_players");
        let game_timer = getScore("fear:settings","hns.mobs.timer_minutes");
        let compass = getScore("fear:settings","hns.mobs.compass");
        let compass1 = Boolean(compass);
        let form2 = new ModalFormData()

        form2.title("%options.editSettings");
        form2.slider("%fearcube.hns.setting.time_game", 3, 15, 1, game_timer )
        form2.slider("%fearcube.hns.setting.tume_lobby", 10, 60, 10, lobby_timer )
        form2.slider("%fearcube.hns.setting.players", 2, 10, 1, minimum_players )
        form2.toggle("%fearcube.hns.setting.compass", compass1)


        form2.show(player).then(r => {
            if (r.canceled) return;
            let [ slider, slider1, slider2, toggle ] = r.formValues;
            runcmd(`scoreboard players set "hns.mobs.timer_minutes" fear:settings ${slider}`)
            runcmd(`scoreboard players set "hns.mobs.timer_lobby" fear:settings ${slider1}`)
            runcmd(`scoreboard players set "hns.mobs.minimum_players" fear:settings ${slider2}`)
            runcmd(`scoreboard players set "hns.mobs.compass" fear:settings ${BoolToNum(toggle)}`)
        }).catch(e => {
            console.error(e, e.stack);
        });    
    }
    if (event.id === "fearcube:forms",event.message === "settings_hns.mobs_info") {

        let player = event.sourceEntity
        let lobby_timer = getScore("fear:settings","hns.mobs.timer_lobby");
        let minimum_players = getScore("fear:settings","hns.mobs.minimum_players");
        let game_timer = getScore("fear:settings","hns.mobs.timer_minutes");
        let compass = getScore("fear:settings","hns.mobs.compass");
        let C = "";

        if (compass >= 1) {C = "%fearcube.included";} else {C = "%fearcube.turned_off";}


        let form = new ActionFormData();
        form.body(`\n §l%fearcube.hns.setting.game %fearcube.hns.name §r\n\n\n §7%fearcube.hns.setting.time_game: §a${game_timer} §r\n §7%fearcube.hns.setting.tume_lobby: §a${lobby_timer} §r\n §7%fearcube.hns.setting.players: §a${minimum_players} §r\n §7%fearcube.hns.setting.compass: §a${C} \n\n\n\n\n§r `);
        form.button("%dr.button.ok ");

        form.show(player).then(r => {}).catch((e) => {
            console.error(e, e.stack);
        });
    
    }



    if (event.id === "fearcube:forms",event.message === "hns_lobby_settings") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
    
        let form = new ActionFormData();
        form.title("%fearcube.hns.name");
        form.body(``);
        form.button(`%fearcube.tune`, "textures/icon/reset");
        form.button(`%options.editSettings`, "textures/icon/change_settings");
        form.button(`%fearcube.tune1`, "textures/icon/view_settings");
        form.button(`%onlinePlay.Back`, "textures/icon/back");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'execute as @s[tag=lobby] at @s run function games/hns_mobs/settings/reset')
                    break;
                case 1: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms settings_hns.mobs')
                    break;
                case 2: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms settings_hns.mobs_info')
                    break;
                case 3: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms hns_lobby')
                   break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }


    if (event.id === "fearcube:forms",event.message === "hns_select_mob") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
    
        let form = new ActionFormData();
        form.title("%fearcube.hns.name");
        form.body(``);
        form.button(`%entity.chicken.name \n%course.edu.learnMoreButton`, "textures/select_mob/chicken");
        form.button(`%entity.pig.name \n%course.edu.learnMoreButton`, "textures/select_mob/pig");
        form.button(`%entity.sheep.name \n%course.edu.learnMoreButton`, "textures/select_mob/sheep");
        form.button(`%entity.cow.name \n%course.edu.learnMoreButton`, "textures/select_mob/cow");
        form.button(`%entity.cat.name \n%course.edu.learnMoreButton`, "textures/select_mob/cat");
        form.button(`%entity.fox.name \n%course.edu.learnMoreButton`, "textures/select_mob/fox");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'scriptevent fearcube:forms hns_select_mob_chicken')
                    break;
                case 1: runcmd_at(name, 'scriptevent fearcube:forms hns_select_mob_pig')
                    break;
                case 2: runcmd_at(name, 'scriptevent fearcube:forms hns_select_mob_sheep')
                    break;
                case 3: runcmd_at(name, 'scriptevent fearcube:forms hns_select_mob_cow')
                   break;
                case 4: runcmd_at(name, 'scriptevent fearcube:forms hns_select_mob_cat')
                   break;
                case 5: runcmd_at(name, 'scriptevent fearcube:forms hns_select_mob_fox')
                   break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }


    if (event.id === "fearcube:forms",event.message === "hns_select_mob_pig") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name
    
        let form1 = new MessageFormData();
        form1.title("%fearcube.hns.name");
        form1.body("§l%fearcube.capabilities: \n\n§r§a %fearcube.hns.skill_active1 - §7%fearcube.hns.skill_pig1: §7\n%fearcube.hns.skill_pig1.1\n\n§a %fearcube.hns.skill_passive - §7%fearcube.hns.skill_pig: §7\n%fearcube.hns.skill_pig1.2");
        form1.button1("%createWorldScreen.clearPlayerData.cancel");
        form1.button2("%authentication.store.confirm.button");
        form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
            return }
        world.getDimension("overworld").runCommandAsync(`execute as "${name}" at @s run function games/hns_mobs/game/select_mob/pig`);
        
        }).catch((e) => { console.error(e, e.stack); });
    
    } 

    if (event.id === "fearcube:forms",event.message === "hns_select_mob_chicken") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name
    
        let form1 = new MessageFormData();
        form1.title("%fearcube.hns.name");
        form1.body("§l%fearcube.capabilities: \n\n§r§a %fearcube.hns.skill_active1 - §7%fearcube.hns.skill_chicken1: §7\n%fearcube.hns.skill_chicken1.1\n\n§a %fearcube.hns.skill_passive - §7%fearcube.hns.skill_chicken: §7\n%fearcube.hns.skill_chicken1.2");
        form1.button1("%createWorldScreen.clearPlayerData.cancel");
        form1.button2("%authentication.store.confirm.button");
        form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
            return }
        world.getDimension("overworld").runCommandAsync(`execute as "${name}" at @s run function games/hns_mobs/game/select_mob/chicken`);
        
        }).catch((e) => { console.error(e, e.stack); });
    
    }    
    if (event.id === "fearcube:forms",event.message === "hns_select_mob_sheep") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name
    
        let form1 = new MessageFormData();
        form1.title("%fearcube.hns.name");
        form1.body("§l%fearcube.capabilities: \n\n§r§a %fearcube.hns.skill_active1 - §7%fearcube.hns.skill_sheep1: §7\n%fearcube.hns.skill_sheep1.1\n\n§a %fearcube.hns.skill_passive - §7%fearcube.hns.skill_sheep: §7\n%fearcube.hns.skill_sheep1.2");
        form1.button1("%createWorldScreen.clearPlayerData.cancel");
        form1.button2("%authentication.store.confirm.button");
        form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
            return }
        world.getDimension("overworld").runCommandAsync(`execute as "${name}" at @s run function games/hns_mobs/game/select_mob/sheep`);
        
        }).catch((e) => { console.error(e, e.stack); });
    
    }   

    if (event.id === "fearcube:forms",event.message === "hns_select_mob_cow") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name
    
        let form1 = new MessageFormData();
        form1.title("%fearcube.hns.name");
        form1.body("§l%fearcube.capabilities: \n\n§r§a %fearcube.hns.skill_active1 - §7%fearcube.hns.skill_cow1: §7\n%fearcube.hns.skill_cow1.1\n\n§a %fearcube.hns.skill_passive - §7%fearcube.hns.skill_cow: §7\n%fearcube.hns.skill_cow1.2");
        form1.button1("%createWorldScreen.clearPlayerData.cancel");
        form1.button2("%authentication.store.confirm.button");
        form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
            return }
        world.getDimension("overworld").runCommandAsync(`execute as "${name}" at @s run function games/hns_mobs/game/select_mob/cow`);
        
        }).catch((e) => { console.error(e, e.stack); });
    
    } 
    if (event.id === "fearcube:forms",event.message === "hns_select_mob_cat") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name
    
        let form1 = new MessageFormData();
        form1.title("%fearcube.hns.name");
        form1.body("§l%fearcube.capabilities: \n\n§r§a %fearcube.hns.skill_active1 - §7%fearcube.hns.skill_cat1: §7\n%fearcube.hns.skill_cat1.1\n\n§a %fearcube.hns.skill_passive - §7%fearcube.hns.skill_cat: §7\n%fearcube.hns.skill_cat1.2");
        form1.button1("%createWorldScreen.clearPlayerData.cancel");
        form1.button2("%authentication.store.confirm.button");
        form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
            return }
        world.getDimension("overworld").runCommandAsync(`execute as "${name}" at @s run function games/hns_mobs/game/select_mob/cat`);
        
        }).catch((e) => { console.error(e, e.stack); });
    
    } 
    if (event.id === "fearcube:forms",event.message === "hns_select_mob_fox") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name
    
        let form1 = new MessageFormData();
        form1.title("%fearcube.hns.name");
        form1.body("§l%fearcube.capabilities: \n\n§r§a %fearcube.hns.skill_active1 - §7%fearcube.hns.skill_fox1: §7\n%fearcube.hns.skill_fox1.1\n\n§a %fearcube.hns.skill_passive - §7%fearcube.hns.skill_fox: §7\n%fearcube.hns.skill_fox1.2");
        form1.button1("%createWorldScreen.clearPlayerData.cancel");
        form1.button2("%authentication.store.confirm.button");
        form1.show(player).then(r => {
            if(r.canceled || r.selection == 0){
            return }
        world.getDimension("overworld").runCommandAsync(`execute as "${name}" at @s run function games/hns_mobs/game/select_mob/fox`);
        
        }).catch((e) => { console.error(e, e.stack); });
    
    } 

    if (event.id === "fearcube:forms",event.message === "hns_select_arens") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
    
        let form = new ActionFormData();
        form.title("%fearcube.hns.name");
        form.body(`%fearcube.hns.arena`);
        form.button(`§l§4№1§r %fearcube.hns.arena1 \n%fearcube.builders: Ruslan IV2088`, "textures/icon/arens/hns_arena1");
        form.button(`§l§4№2§r %fearcube.hns.arena2\nFearCubeBuilders`, "textures/icon/arens/hns_arena2");
        form.button(`§l§4№3§r %fearcube.hns.arena3 \n%fearcube.builders: Ruslan IV2088`, "textures/icon/arens/hns_arena3");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'function games/hns_mobs/lobby/arens/arena1')
                    break;
                case 1: runcmd_at(name, 'function games/hns_mobs/lobby/arens/arena2')
                    break;
                case 2: runcmd_at(name, 'function games/hns_mobs/lobby/arens/arena3')
                    break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }




























});