import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { system, world } from '@minecraft/server';
import { runcmd, runcmd_at, BoolToNum, getScore } from '../../systemFiles/tools';



system.afterEvents.scriptEventReceive.subscribe((event) => {
if (event.id === "fearcube:forms",event.message === "settings_mm") {

    let player = event.sourceEntity
    let lobby_timer = getScore("fear:settings","mm.timer_lobby");
    let minimum_players = getScore("fear:settings","mm.minimum_players");
    let game_timer = getScore("fear:settings","mm.timer_minutes");
    let form2 = new ModalFormData()
    form2.title("%options.editSettings");
    form2.slider("%fearcube.hns.setting.time_game", 3, 20, 1, game_timer )
    form2.slider("%fearcube.hns.setting.tume_lobby", 10, 60, 10, lobby_timer )
    form2.slider("%fearcube.hns.setting.players", 2, 10, 1, minimum_players )

    form2.show(player).then(r => {
        if (r.canceled) return;
        let [ slider, slider1, slider2 ] = r.formValues;
        runcmd(`scoreboard players set "mm.timer_minutes" fear:settings ${slider}`)
        runcmd(`scoreboard players set "mm.timer_lobby" fear:settings ${slider1}`)
        runcmd(`scoreboard players set "mm.minimum_players" fear:settings ${slider2}`)
    }).catch(e => {
        console.error(e, e.stack);
    });    
}


if (event.id === "fearcube:forms",event.message === "settings_mm_info") {

    let player = event.sourceEntity
    let lobby_timer = getScore("fear:settings","mm.timer_lobby");
    let minimum_players = getScore("fear:settings","mm.minimum_players");
    let game_timer = getScore("fear:settings","mm.timer_minutes");

    let form = new ActionFormData();
    form.body(`\n §l%fearcube.hns.setting.game %fearcube.mm.name §r\n\n\n §7%fearcube.hns.setting.time_game: §a${game_timer} §r\n §7%fearcube.hns.setting.tume_lobby: §a${lobby_timer} §r\n §7%fearcube.hns.setting.players: §a${minimum_players} \n\n\n\n\n§r `);
    form.button("%dr.button.ok ");

    form.show(player).then(r => {}).catch((e) => {
        console.error(e, e.stack);
    });

}

if (event.id === "fearcube:forms",event.message === "mm_lobby") {
    let player = event.sourceEntity
    let name = event.sourceEntity.name  

    let form = new ActionFormData();
    
    form.title("%fearcube.mm.name");
    form.body(``);
    form.button(`%playscreen.header.local`, "textures/icon/sword");
    form.button(`%store.promo.details`, "textures/items/map_information");

    form.show(player).then(r => {
        if (r.canceled) return;
        let response = r.selection;
        switch (response) {
            case 0: runcmd_at(name, 'execute as @s[tag=lobby] at @s run function games/mm/lobby/to_lobby')
                break;
            case 1: runcmd_at(name, 'execute as @s[tag=lobby] at @s run function setting_rights/mm')
                break;
            default:
        }
    }).catch(e => {
        console.error(e, e.stack);
    });

    }

    if (event.id === "fearcube:forms",event.message === "mm_lobby_settings") {
        let name = event.sourceEntity.name  
        let player = event.sourceEntity
    
        let form = new ActionFormData();
        form.title("%fearcube.mm.name");
        form.body(``);
        form.button(`%fearcube.tune`, "textures/icon/reset");
        form.button(`%options.editSettings`, "textures/icon/change_settings");
        form.button(`%fearcube.tune1`, "textures/icon/view_settings");
        form.button(`%onlinePlay.Back`, "textures/icon/back");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'execute as @s[tag=lobby] at @s run function games/mm/settings/reset')
                    break;
                case 1: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms settings_mm')
                    break;
                case 2: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms settings_mm_info')
                    break;
                case 2: runcmd_at(name, 'execute as @s[tag=lobby] at @s run scriptevent fearcube:forms mm_lobby')
                    break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }

    if (event.id === "fearcube:forms",event.message === "mm_role_murder") {
        let player = event.sourceEntity
        let form = new ActionFormData();
        form.title("%fearcube.mm.name");
        form.body(`\n\n\n\n\n              §7%fearcube.mm.role §c%fearcube.mm.role_murder                                                                                                                                                                                                                                                                                     `);
        form.button(`%dr.button.ok`);
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }

    if (event.id === "fearcube:forms",event.message === "mm_role_detective") {
        let player = event.sourceEntity
        let form = new ActionFormData();
        form.title("%fearcube.mm.name");
        form.body(`\n\n\n\n\n              §7%fearcube.mm.role §a%fearcube.mm.role_detective                                                                                                                                                                                                                                                                                       `);
        form.button(`%dr.button.ok`);
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }

    if (event.id === "fearcube:forms",event.message === "mm_role_civilian") {
        let player = event.sourceEntity
        let form = new ActionFormData();
        form.title("%fearcube.mm.name");
        form.body(`\n\n\n\n\n              §7%fearcube.mm.role §6%fearcube.mm.role_civilian                                                                                                                                                                                                                                                                                        `);
        form.button(`%dr.button.ok`);
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }

    if (event.id === "fearcube:forms",event.message === "mm_select_arens") {
        let player = event.sourceEntity
        let name = event.sourceEntity.name  
    
        let form = new ActionFormData();
        form.title("%fearcube.mm.name");
        form.body(``);
        form.button(`§l§4№1§r %fearcube.mm.arena1\nHypixelBuilders`, "textures/icon/arens/mm_arena1");
        form.button(`§l§4№2§r %fearcube.mm.arena2\nHypixelBuilders`, "textures/icon/arens/mm_arena2");
        form.button(`§l§4№3§r %fearcube.mm.arena3\nHypixelBuilders`, "textures/icon/arens/mm_arena3");
        form.button(`§l§4№4§r %fearcube.mm.arena4\nHypixelBuilders`, "textures/icon/arens/mm_arena4");
        form.button(`§l§4№5§r %fearcube.mm.arena5\nHypixelBuilders`, "textures/icon/arens/mm_arena5");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: runcmd_at(name, 'function games/mm/lobby/arens/arena1')
                    break;
                case 1: runcmd_at(name, 'function games/mm/lobby/arens/arena2')
                    break;
                case 2: runcmd_at(name, 'function games/mm/lobby/arens/arena3')
                    break;
                case 3: runcmd_at(name, 'function games/mm/lobby/arens/arena4')
                   break;
                case 4: runcmd_at(name, 'function games/mm/lobby/arens/arena5')
                   break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }



});