import { system, world } from '@minecraft/server';
import { getPlayerTagData, getTagValue } from '../../systemFiles/tagUtils.js';
import { runcmd, runcmd_at, BoolToNum, getScore } from '../../systemFiles/tools';

system.afterEvents.scriptEventReceive.subscribe((event) => {
    if (event.id === "fearcube:ui" && event.message === "MM_UI") {
        const player = event.sourceEntity;
        let excerpt = getScore("mm:timer_issued_roles","mm:pre_timer");
        let animTimer = getScore("fear_operation","timer:game");
        let zeroTimer = getScore("mm:operation","mm.timer_seconds");
        let detectiveAlive = `,{"text":" §c"},{"translate":"fearcube:glimpse_dead"}`;
        

        const players = world.getPlayers(); 
        players.forEach(detective => {
            if (detective.hasTag("mm:detective")) {
                detectiveAlive = `,{"text":" §a"},{"translate":"fearcube:glimpse_alive"}`;
            }
        });

        let setTimer = "";
        if (animTimer >= 20 && animTimer < 40) {setTimer = "";} 
        else if (animTimer >= 40 && animTimer < 60) { setTimer = "";} 
        else if (animTimer >= 60 && animTimer < 80) { setTimer = "";} 
        else if (animTimer >= 80 && animTimer < 100) { setTimer = "";} 
        else if (animTimer >= 100 && animTimer < 120) { setTimer = "";} 
        else if (animTimer >= 120 && animTimer < 140) { setTimer = "";} 
        else if (animTimer >= 140 && animTimer < 160) { setTimer = "";} 
        else if (animTimer <= 20 && animTimer < 180) { setTimer = "";}

        
        let addZero = "";
        if (zeroTimer >= 0 && zeroTimer < 10 ) {addZero = "0"}        



        let your_role = "";
        if (excerpt <= 0) {
            if (player.hasTag("mm:civilian")) {your_role = `,{"text":" §6"},{"translate":"fearcube.mm.role_civilian"}`}
            if (player.hasTag("mm:detective")) {your_role = `,{"text":" §a"},{"translate":"fearcube.mm.role_detective"}`}
            if (player.hasTag("mm:murder")) {your_role = `,{"text":" §c"},{"translate":"fearcube.mm.role_murder"}`}
        }

        let name_game = `{"translate":"fearcube.mm.name1"}`;
        let civilian = `,{"text":"\n\n§2  "},{"translate":"fearcube.mm.tag_civilian"},{"text":"§c "},{"score":{"name":"how_civilian","objective":"mm:operation"}}`;
        let its_detective = `,{"text":"\n§2 "},{"translate":"fearcube.mm.role_detective"}${detectiveAlive}`;
        let coins = `,{"text":"\n§2  "},{"translate":"fearcube.mm.coin"},{"text":"§c "},{"score":{"name":"@s","objective":"mm:coins"}}`;
        let timer = `,{"text":"\n\n§2 ${setTimer}"},{"translate":"fearcube.timer"},{"text":"§c "},{"score":{"name":"mm.timer_minutes","objective":"mm:operation"}},{"text":"§2:§c${addZero}"},{"score":{"name":"mm.timer_seconds","objective":"mm:operation"}}`;
        let viewers = `,{"text":"\n §2"},{"translate":"fearcube.viewers"},{"text":"§c "},{"score":{"name":"how_viewer","objective":"mm:operation"}}`;
        let role = `,{"text":"\n\n§2"},{"translate":"fearcube.mm.role"}${your_role}`;
        let website = `,{"text":"\n\n§b  "},{"translate":"fearcube.website"}`;

        player.runCommandAsync(`titleraw @s title {"rawtext":[${name_game} ${civilian} ${its_detective} ${coins} ${timer} ${viewers} ${role} ${website}]}`);
    }  
});
