import { system, world } from '@minecraft/server';
import { getTagValue } from '../systemFiles/tagUtils';
import { runcmd_at } from '../systemFiles/tools';

system.afterEvents.scriptEventReceive.subscribe((event) => {
    if (event.id === "fearcube:lvl" && event.message === "up_level") {
        let player = event.sourceEntity;
        let name = player.name;

        const next_exp = getTagValue(player, "next_exp");
        const experience = getTagValue(player, "experience");

        if (experience > next_exp) {
            const ten_percent_next_exp = next_exp * 0.1;
            const lvl = getTagValue(player, "lvl");

            const levelUpMessages = [
                "fearcube.level_up1", "fearcube.level_up2", "fearcube.level_up3",
                "fearcube.level_up4", "fearcube.level_up5", "fearcube.level_up6",
                "fearcube.level_up7", "fearcube.level_up8", "fearcube.level_up9",
                "fearcube.level_up10", "fearcube.level_up11", "fearcube.level_up12",
                "fearcube.level_up13", "fearcube.level_up14", "fearcube.level_up15"
            ];

            player.runCommandAsync(`scriptevent fearcube:add_tag lvl=1`);
            player.runCommandAsync(`playsound random.levelup @s ~~~ 1 1`);
            player.runCommandAsync(`scriptevent fearcube:remove_tag experience=${next_exp}`);
            player.runCommandAsync(`scriptevent fearcube:add_tag next_exp=${ten_percent_next_exp}`);

            player.runCommandAsync(`tellraw @a[tag=fear:logs] {"rawtext":[{"text":"§a...events/check_up_level?/${name}/next_experience=${next_exp}/experience=${experience}/lvl=${lvl}/ten_percent=${ten_percent_next_exp}"}]}`);

            const randomIndex = Math.floor(Math.random() * levelUpMessages.length);
            const messageKey = levelUpMessages[randomIndex];

            runcmd_at(name, `tellraw @s {"rawtext":[{"text":" §a"},{"translate":"${messageKey}"},{"text":" §c ${lvl + 1}"}]}`, true);
        }
    }
});
