import { system, world, Player } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import {  getTagValue, updateTagData } from '../../systemFiles/tagUtils.js';
import { runcmd, runcmd_at, BoolToNum, getScore } from '../../systemFiles/tools';

        // hat:birthday_present
        // hat:party
        // hat:crown_cake
        // hat:jester
        // hat:boombox
        // hat:propeller
        // hat:chicken_jockey


function shoopsClothHats(player, name) {
    let form = new ActionFormData();
    const money = getTagValue(player, "money");
    
    let hat_birthday_present = ""; let hat_boombox = ""; let hat_chicken_jockey = ""; let hat_crown_cake = ""; let hat_jester = ""; let hat_party = ""; let hat_propeller = ""; let price = "";

    if (player.hasTag("hat:birthday_present")) {hat_birthday_present = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:birthday_present_true")) { hat_birthday_present = "%fearcube.shop.bought"}
        else { price = "299"; if (money >= price) { hat_birthday_present = `§2${price}$`} else {hat_birthday_present = `§4${price}$`}}; }

    if (player.hasTag("hat:party")) {hat_party = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:party_true")) { hat_party = "%fearcube.shop.bought"}
        else { price = "399"; if (money >= price) { hat_party = `§2${price}$`} else {hat_party = `§4${price}$`}}}

    if (player.hasTag("hat:crown_cake")) {hat_crown_cake = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:crown_cake_true")) { hat_crown_cake = "%fearcube.shop.bought"}
        else { price = "499"; if (money >= price) { hat_crown_cake = `§2${price}$`} else {hat_crown_cake = `§4${price}$`}}}

    if (player.hasTag("hat:jester")) {hat_jester = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:jester_true")) { hat_jester = "%fearcube.shop.bought"}
        else { price = "599"; if (money >= price) { hat_jester = `§2${price}$`} else {hat_jester = `§4${price}$`}}}

    if (player.hasTag("hat:boombox")) {hat_boombox = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:boombox_true")) { hat_boombox = "%fearcube.shop.bought"}
        else { price = "699"; if (money >= price) { hat_boombox = `§2${price}$`} else {hat_boombox = `§4${price}$`}}}

    if (player.hasTag("hat:propeller")) {hat_propeller = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:propeller_true")) { hat_propeller = "%fearcube.shop.bought"}
        else { price = "799"; if (money >= price) { hat_propeller = `§2${price}$`} else {hat_propeller = `§4${price}$`}}}

    if (player.hasTag("hat:chicken_jockey")) {hat_chicken_jockey = "%fearcube.shop.selected"} else {
        if (player.hasTag("hat:chicken_jockey_true")) { hat_chicken_jockey = "%fearcube.shop.bought"}
        else { price = "999"; if (money >= price) { hat_chicken_jockey = `§2${price}$`} else {hat_chicken_jockey = `§4${price}$`}}}



    form.title(" Hat store");
    form.button(`${hat_birthday_present}`, "textures/shoop/hats/hat_birthday_present");
    form.button(`${hat_party}`, "textures/shoop/hats/hat_party");
    form.button(`${hat_crown_cake}`, "textures/shoop/hats/hat_crown_cake");
    form.button(`${hat_jester}`, "textures/shoop/hats/hat_jester");
    form.button(`${hat_boombox}`, "textures/shoop/hats/hat_boombox");
    form.button(`${hat_propeller}`, "textures/shoop/hats/hat_propeller");
    form.button(`${hat_chicken_jockey}`, "textures/shoop/hats/hat_chicken_jockey");

    form.show(player).then(r => {
        if (r.canceled) return;
        let response = r.selection;
        switch (response) {

            case 0: 
            price = "299";
            SubjectBuy_hat_birthday_present(player, money, name, price)
            break;

            case 1: 
            price = "399";
            SubjectBuy_hat_party(player, money, name, price)
            break;

            case 2: 
            price = "499";
            SubjectBuy_hat_crown_cake(player, money, name, price)
            break;

            case 3: 
            price = "599";
            SubjectBuy_hat_jester(player, money, name, price)
            break;

            case 4: 
            price = "699";
            SubjectBuy_hat_boombox(player, money, name, price)
            break;

            case 5: 
            price = "799";
            SubjectBuy_hat_propeller(player, money, name, price)
            break;

            case 6: 
            price = "999";
            SubjectBuy_hat_chicken_jockey(player, money, name, price)
            break;
        }
    }).catch(e => { console.error(e, e.stack); });
}


function SubjectSelectionHats(player, items, name) {

    let form1 = new MessageFormData();

    form1.title(" ");
    form1.body(`%fearcube.shop.hats.select  %${checkingSubject(items).nameItem}?`);
    form1.button1("%gui.no");
    form1.button2("%gui.yes");

    form1.show(player).then(r => {
        if (r.canceled || r.selection == 0) return;

        removeTagHats(player);
        if (parseInt(items) === 1) {
            player.addTag(`hat:birthday_present`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_birthday_present 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }
        if (parseInt(items) === 2) {
            player.addTag(`hat:party`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_party 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }
        if (parseInt(items) === 3) {
            player.addTag(`hat:crown_cake`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_crown_cake 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }
        if (parseInt(items) === 4) {
            player.addTag(`hat:jester`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_jester 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }
        if (parseInt(items) === 5) {
            player.addTag(`hat:boombox`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_boombox 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }
        if (parseInt(items) === 6) {
            player.addTag(`hat:propeller`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_propeller 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }
        if (parseInt(items) === 7) {
            player.addTag(`hat:chicken_jockey`);
            player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 fear:hat_chicken_jockey 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}`);
        }

        runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§a"},{"translate":"fearcube.shop.hats.selected"},{"text":" §l"},{"translate":"${checkingSubject(items).nameItem}"}]}`);
        runcmd_at(name, `tellraw @a[tag=fear:logs] {"rawtext":[{"text":"§a...events/hat/${name}/${checkingSubject(items).nameItem}"}]}`);
        runcmd_at(name, `playsound ui.loom.take_result @s ~~~ 1 1.5`);
        
    }).catch((e) => {
        console.error(e, e.stack);
    });
}




function SubjectBuy(player, items, name, money, price) {
    let value = price;
    let key = "money"
    let { nameItem } = checkingSubject(items);
    let form1 = new MessageFormData();
    form1.title(" ");
    form1.body(`%fearcube.shop.hats.buy %${nameItem}?`);
    form1.button1("%gui.no");
    form1.button2("%gui.yes");
    form1.show(player).then(r => {
    if(r.canceled || r.selection == 0){
     return }

     if ( price <= money) {    
        if (items === 1 ) { player.addTag(`hat:birthday_present_true`);}
        if (items === 2 ) { player.addTag(`hat:party_true`);}
        if (items === 3 ) { player.addTag(`hat:crown_cake_true`);}
        if (items === 4 ) { player.addTag(`hat:jester_true`);}
        if (items === 5 ) { player.addTag(`hat:boombox_true`);}
        if (items === 6 ) { player.addTag(`hat:propeller_true`);}
        if (items === 7 ) { player.addTag(`hat:chicken_jockey_true`);}


        updateTagData(player, key, parseInt(value), false)
        runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§a"},{"translate":"fearcube.shop.hats.bought"},{"text":" §l"},{"translate":"${nameItem}"}]}`);
        runcmd_at(name, `playsound mob.villager.yes @s ~~~ 1 1.5`);
    } else {
        runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§c"},{"translate":"fearcube.shop.nickname.error1"},{"text":"§6 ${price - money}$"}]}`)
        runcmd_at(name, `playsound mob.villager.no @s ~~~ 1 1.5`);
    }



    shoopsClothHats(player, name)
    }).catch((e) => { console.error(e, e.stack); });
}






function SubjectShutdownHats(player, name) {
    let form1 = new MessageFormData();

    form1.title(" ");
    form1.body(`%fearcube.shop.hats.take_off?`);
    form1.button1("%gui.no");
    form1.button2("%gui.yes");


    form1.show(player).then(r => {
    if(r.canceled || r.selection == 0){
     return }

     removeTagHats(player); 
     runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§a "},{"translate":"fearcube.shop.hats.taken_off"}]}`)
     runcmd_at(name, `playsound fall.egg @s ~~~ 1 1`)
     
    
    }).catch((e) => { console.error(e, e.stack); });
}




function removeTagHats(player) {
    player.removeTag(`hat:birthday_present`);
    player.removeTag(`hat:party`);
    player.removeTag(`hat:crown_cake`);
    player.removeTag(`hat:jester`);
    player.removeTag(`hat:boombox`);
    player.removeTag(`hat:propeller`);
    player.removeTag(`hat:chicken_jockey`);
    player.runCommandAsync(`replaceitem entity @s slot.armor.head 0 air`);
}


function checkingSubject(items) {
    let nameItem = "";
    if (items === 1) { nameItem = "fearcube.hat_birthday_present";}
    if (items === 2) { nameItem = "fearcube.hat_party";}
    if (items === 3) { nameItem = "fearcube.hat_crown_cake";}
    if (items === 4) { nameItem = "fearcube.hat_jester";}
    if (items === 5) { nameItem = "fearcube.hat_boombox";}
    if (items === 6) { nameItem = "fearcube.hat_propeller";}
    if (items === 7) { nameItem = "fearcube.hat_chicken_jockey";}
    return { nameItem }
}


function SubjectBuy_hat_birthday_present(player, money, name, price) {
    let items = 1;
    if (player.hasTag("hat:birthday_present") && player.hasTag("hat:birthday_present_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:birthday_present_true") && !player.hasTag("hat:birthday_present")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:birthday_present_true") && !player.hasTag("hat:birthday_present")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_hat_party(player, money, name, price) {
    let items = 2;
    if (player.hasTag("hat:party") && player.hasTag("hat:party_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:party_true") && !player.hasTag("hat:party")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:party_true") && !player.hasTag("hat:party")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_hat_crown_cake(player, money, name, price) {
    let items = 3;
    if (player.hasTag("hat:crown_cake") && player.hasTag("hat:crown_cake_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:crown_cake_true") && !player.hasTag("hat:crown_cake")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:crown_cake_true") && !player.hasTag("hat:crown_cake")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_hat_jester(player, money, name, price) {
    let items = 4;
    if (player.hasTag("hat:jester") && player.hasTag("hat:jester_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:jester_true") && !player.hasTag("hat:jester")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:jester_true") && !player.hasTag("hat:jester")) { 
        SubjectBuy(player, items, name, money, price)}
}


function SubjectBuy_hat_boombox(player, money, name, price) {
    let items = 5;
    if (player.hasTag("hat:boombox") && player.hasTag("hat:boombox_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:boombox_true") && !player.hasTag("hat:boombox")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:boombox_true") && !player.hasTag("hat:boombox")) { 
        SubjectBuy(player, items, name, money, price)}
}


function SubjectBuy_hat_propeller(player, money, name, price) {
    let items = 6;
    if (player.hasTag("hat:propeller") && player.hasTag("hat:propeller_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:propeller_true") && !player.hasTag("hat:propeller")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:propeller_true") && !player.hasTag("hat:propeller")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_hat_chicken_jockey(player, money, name, price) {
    let items = 7;
    if (player.hasTag("hat:chicken_jockey") && player.hasTag("hat:chicken_jockey_true")) { 
        SubjectShutdownHats(player, name);}

    if (player.hasTag("hat:chicken_jockey_true") && !player.hasTag("hat:chicken_jockey")) { 
        SubjectSelectionHats(player, items, name, money );}

    if (!player.hasTag("hat:chicken_jockey_true") && !player.hasTag("hat:chicken_jockey")) { 
        SubjectBuy(player, items, name, money, price)}
}




export { shoopsClothHats, SubjectSelectionHats, SubjectShutdownHats };