import { system, world, Player } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import {  getTagValue, updateTagData } from '../../systemFiles/tagUtils.js';
import {  setLobbyNickname } from '../nickname.js';
import {  shoopsNickname } from '../shoops/nickname.js';
import {  shoopsClothHats } from '../shoops/custom_cloth.js';
import {  shoopsSmiley } from '../shoops/smiley.js';



system.afterEvents.scriptEventReceive.subscribe((event) => {
    if (event.id === "fearcube:shoop",event.message === "main1") {
    
        let player = event.sourceEntity
        let name = event.sourceEntity.name
        let money = getTagValue(player, "money");
    
        let form = new ActionFormData();
        form.title("%fearcube.shop");
        form.body(`§6§l %fearcube.balance: §a${money}$`);
        
        form.button(`%fearcube.shop.nicknames`, "textures/icon/other/shoopNickname");
        form.button(`%fearcube.shop.smiley`, "textures/icon/other/smiley");
        form.button(`%fearcube.shop.hats`, "textures/icon/other/shoopHats");
    
        form.show(player).then(r => {
            if (r.canceled) return;
            let response = r.selection;
            switch (response) {
                case 0: shoopsNickname(player, name)
                    break;
                case 1: shoopsSmiley(player, name)
                    break;
                case 2: shoopsClothHats(player, name)
                    break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    }
});