import { system, world, Player } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import {  getTagValue, updateTagData } from '../../systemFiles/tagUtils.js';
import {  setLobbyNickname } from '../nickname.js';
import { runcmd, runcmd_at, BoolToNum, getScore } from '../../systemFiles/tools';


system.afterEvents.scriptEventReceive.subscribe((event) => {
if (event.id === "fearcube:shoop",event.message === "nickname") {


    let player = event.sourceEntity
    let name = event.sourceEntity.name
    shoopsNickname(player, name)

}});


function shoopsNickname(player, name) {
    let form = new ActionFormData();
    const money = getTagValue(player, "money");
    
    

    let dark_blue = ""; let dark_green = ""; let dark_aqua = ""; let dark_red = ""; let dark_purple = ""; let gold = ""; let gray = ""; let black = ""; 
    let blue = ""; let green = ""; let aqua = ""; let red = ""; let light_purple = ""; let yellow = ""; let white = ""; let dark_gray = ""; let price = "";

    if (player.hasTag("nickname:black")) {black = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:black_true")) { black = "%fearcube.shop.bought"}
    else { price = "299"; if (money >= price) { black = `§2${price}$`} else {black = `§4${price}$`}}; }

    if (player.hasTag("nickname:dark_blue")) {dark_blue = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:dark_blue_true")) { dark_blue = "%fearcube.shop.bought"}
    else { price = "299"; if (money >= price) { dark_blue = `§2${price}$`} else {dark_blue = `§4${price}$`}}}

    if (player.hasTag("nickname:dark_green")) {dark_green = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:dark_green_true")) { dark_green = "%fearcube.shop.bought"}
    else { price = "399"; if (money >= price) { dark_green = `§2${price}$`} else {dark_green = `§4${price}$`}}}

    if (player.hasTag("nickname:dark_aqua")) {dark_aqua = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:dark_aqua_true")) { dark_aqua = "%fearcube.shop.bought"}
    else { price = "399"; if (money >= price) { dark_aqua = `§2${price}$`} else {dark_aqua = `§4${price}$`}}}

    if (player.hasTag("nickname:dark_red")) {dark_red = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:dark_red_true")) { dark_red = "%fearcube.shop.bought"}
    else { price = "499"; if (money >= price) { dark_red = `§2${price}$`} else {dark_red = `§4${price}$`}}}

    if (player.hasTag("nickname:dark_purple")) {dark_purple = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:dark_purple_true")) { dark_purple = "%fearcube.shop.bought"}
    else { price = "499"; if (money >= price) { dark_purple = `§2${price}$`} else {dark_purple = `§4${price}$`}}}

    if (player.hasTag("nickname:gold")) {gold = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:gold_true")) { gold = "%fearcube.shop.bought"}
    else { price = "499"; if (money >= price) { gold = `§2${price}$`} else {gold = `§4${price}$`}}}

    if (player.hasTag("nickname:gray")) {gray = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:gray_true")) { gray = "%fearcube.shop.bought"}
    else { price = "599"; if (money >= price) { gray = `§2${price}$`} else {gray = `§4${price}$`}}}

    if (player.hasTag("nickname:dark_gray")) {dark_gray = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:dark_gray_true")) { dark_gray = "%fearcube.shop.bought"}
    else { price = "10"; if (money >= price) { dark_gray = `§2${price}$`} else {dark_gray = `§4${price}$`}}}

    if (player.hasTag("nickname:blue")) {blue = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:blue_true")) { blue = "%fearcube.shop.bought"}
    else { price = "599"; if (money >= price) { blue = `§2${price}$`} else {blue = `§4${price}$`}}}

    if (player.hasTag("nickname:green")) {green = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:green_true")) { green = "%fearcube.shop.bought"}
    else { price = "699"; if (money >= price) { green = `§2${price}$`} else {green = `§4${price}$`}}}

    if (player.hasTag("nickname:aqua")) {aqua = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:aqua_true")) { aqua = "%fearcube.shop.bought"}
    else { price = "799"; if (money >= price) { aqua = `§2${price}$`} else {aqua = `§4${price}$`}}}

    if (player.hasTag("nickname:red")) {red = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:red_true")) { red = "%fearcube.shop.bought"}
    else { price = "799"; if (money >= price) { red = `§2${price}$`} else {red = `§4${price}$`}}}

    if (player.hasTag("nickname:light_purple")) {light_purple = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:light_purple_true")) { light_purple = "%fearcube.shop.bought"}
    else { price = "899"; if (money >= price) { light_purple = `§2${price}$`} else {light_purple = `§4${price}$`}}}

    if (player.hasTag("nickname:yellow")) {yellow = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:yellow_true")) { yellow = "%fearcube.shop.bought"}
    else { price = "999"; if (money >= price) { yellow = `§2${price}$`} else {yellow = `§4${price}$`}}}
    
    if (player.hasTag("nickname:white")) {white = "%fearcube.shop.selected"} else {
    if (player.hasTag("nickname:white_true")) { white = "%fearcube.shop.bought"}
    else { price = "999"; if (money >= price) { white = `§2${price}$`} else {white = `§4${price}$`}}}

    

    form.title(" Nicknames");
    form.button(`${black}`, "textures/shoop/colors_nickname/black");
    form.button(`${dark_blue}`, "textures/shoop/colors_nickname/dark_blue");
    form.button(`${dark_green}`, "textures/shoop/colors_nickname/dark_green");
    form.button(`${dark_aqua}`, "textures/shoop/colors_nickname/dark_aqua");
    form.button(`${dark_red}`, "textures/shoop/colors_nickname/dark_red");
    form.button(`${dark_purple}`, "textures/shoop/colors_nickname/dark_purple");
    form.button(`${gold}`, "textures/shoop/colors_nickname/gold");
    form.button(`${gray}`, "textures/shoop/colors_nickname/gray");
    form.button(`${dark_gray}`, "textures/shoop/colors_nickname/dark_gray");
    form.button(`${blue}`, "textures/shoop/colors_nickname/blue");
    form.button(`${green}`, "textures/shoop/colors_nickname/green");
    form.button(`${aqua}`, "textures/shoop/colors_nickname/aqua");
    form.button(`${red}`, "textures/shoop/colors_nickname/red");
    form.button(`${light_purple}`, "textures/shoop/colors_nickname/light_purple");
    form.button(`${yellow}`, "textures/shoop/colors_nickname/yellow");
    form.button(`${white}`, "textures/shoop/colors_nickname/white");

    form.show(player).then(r => {
        if (r.canceled) return;
        let response = r.selection;
        switch (response) {

            case 0: 
            price = "299";
            SubjectBuy_black(player, money, name, price)
            break;

            case 1: 
            price = "299";
            SubjectBuy_dark_blue(player, money, name, price)
            break;

            case 2: 
            price = "399";
            SubjectBuy_dark_green(player, money, name, price)
            break;

            case 3: 
            price = "399";
            SubjectBuy_dark_aqua(player, money, name, price)
            break;

            case 4: 
            price = "499";
            SubjectBuy_dark_red(player, money, name, price)
            break;

            case 5: 
            price = "499";
            SubjectBuy_dark_purple(player, money, name, price)
            break;

            case 6: 
            price = "499";
            SubjectBuy_gold(player, money, name, price)
            break;

            case 7: 
            price = "599";
            SubjectBuy_gray(player, money, name, price)
            break;

            case 8: 
            price = "10";
            SubjectBuy_dark_gray(player, money, name, price)
            break;

            case 9: 
            price = "599";
            SubjectBuy_blue(player, money, name, price)
            break;

            case 10: 
            price = "699";
            SubjectBuy_green(player, money, name, price)
            break;

            case 11: 
            price = "799";
            SubjectBuy_aqua(player, money, name, price)
            break;

            case 12: 
            price = "799";
            SubjectBuy_red(player, money, name, price)
            break;

            case 13: 
            price = "899";
            SubjectBuy_light_purple(player, money, name, price)
            break;

            case 14: 
            price = "999";
            SubjectBuy_yellow(player, money, name, price)
            break;

            case 15: 
            price = "999";
            SubjectBuy_white(player, money, name, price)
            break;
            default:
        }
    }).catch(e => { console.error(e, e.stack); });
}



function SubjectSelectionNickname(player, items, name) {
    let itemID = parseInt(items);

    let { item, color } = checkingGoods(itemID);
    let form1 = new MessageFormData();

    form1.title(" ");
    form1.body(`%fearcube.shop.nickname.select_colors ${color}%${item}?`);
    form1.button1("%gui.no");
    form1.button2("%gui.yes");

    form1.show(player).then(r => {
        if (r.canceled || r.selection == 0) return;

        removeTagNickName(player);
        if (itemID === 1) {
            player.addTag(`nickname:black`);
        }
        if (itemID === 2) {
            player.addTag(`nickname:dark_blue`);
        }
        if (itemID === 3) {
            player.addTag(`nickname:dark_green`);
        }
        if (itemID === 4) {
            player.addTag(`nickname:dark_aqua`);
        }
        if (itemID === 5) {
            player.addTag(`nickname:dark_red`);
        }
        if (itemID === 6) {
            player.addTag(`nickname:dark_purple`);
        }
        if (itemID === 7) {
            player.addTag(`nickname:gold`);
        }
        if (itemID === 8) {
            player.addTag(`nickname:gray`);
        }
        if (itemID === 9) {
            player.addTag(`nickname:dark_gray`);
        }
        if (itemID === 10) {
            player.addTag(`nickname:blue`);
        }
        if (itemID === 11) {
            player.addTag(`nickname:green`);
        }
        if (itemID === 12) {
            player.addTag(`nickname:aqua`);
        }
        if (itemID === 13) {
            player.addTag(`nickname:red`);
        }
        if (itemID === 14) {
            player.addTag(`nickname:light_purple`);
        }
        if (itemID === 15) {
            player.addTag(`nickname:yellow`);
        }
        if (itemID === 16) {
            player.addTag(`nickname:white`);
        }

        setLobbyNickname(player);
        runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§a"},{"translate":"fearcube.shop.nickname.select_color"},{"text":"§l ${color}"},{"translate":"${item}"}]}`);
        runcmd_at(name, `tellraw @a[tag=fear:logs] {"rawtext":[{"text":"§a...events/nickname/change/${name}/${item}"}]}`);
        runcmd_at(name, `playsound ui.loom.take_result @s ~~~ 1 1.5`);
        
    
    }).catch((e) => { console.error(e, e.stack); });
}





function SubjectBuy(player, items, name, money, price) {
    let value = price;
    let key = "money"
    let { item, color } = checkingGoods(items);
    let form1 = new MessageFormData();
    form1.title(" ");
    form1.body(`%fearcube.shop.nickname.bye_color ${color}%${item}?`);
    form1.button1("%gui.no");
    form1.button2("%gui.yes");
    form1.show(player).then(r => {
    if(r.canceled || r.selection == 0){
     return }

     if ( price <= money) {    
        if (items === 1 ) { player.addTag(`nickname:black_true`);}
        if (items === 2 ) { player.addTag(`nickname:dark_blue_true`);}
        if (items === 3 ) { player.addTag(`nickname:dark_green_true`);}
        if (items === 4 ) { player.addTag(`nickname:dark_aqua_true`);}
        if (items === 5 ) { player.addTag(`nickname:dark_red_true`);}
        if (items === 6 ) { player.addTag(`nickname:dark_purple_true`);}
        if (items === 7 ) { player.addTag(`nickname:gold_true`);}
        if (items === 8 ) { player.addTag(`nickname:gray_true`);}
        if (items === 9 ) { player.addTag(`nickname:dark_gray_true`);}
        if (items === 10 ) { player.addTag(`nickname:blue_true`);}
        if (items === 11 ) { player.addTag(`nickname:green_true`);}
        if (items === 12 ) { player.addTag(`nickname:aqua_true`);}
        if (items === 13 ) { player.addTag(`nickname:red_true`);}
        if (items === 14 ) { player.addTag(`nickname:light_purple_true`);}
        if (items === 15 ) { player.addTag(`nickname:yellow_true`);}
        if (items === 16 ) { player.addTag(`nickname:white_true`);}


        updateTagData(player, key, parseInt(value), false)
        runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§a"},{"translate":"fearcube.shop.nickname.bye_colors"},{"text":"§l ${color}"},{"translate":"${item}"}]}`);
        runcmd_at(name, `playsound mob.villager.yes @s ~~~ 1 1.5`);
    } else {
        runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§c"},{"translate":"fearcube.shop.nickname.error1"},{"text":"§6 ${price - money}$"}]}`)
        runcmd_at(name, `playsound mob.villager.no @s ~~~ 1 1.5`);
    }



    shoopsNickname(player, name)
    }).catch((e) => { console.error(e, e.stack); });
}





function SubjectShutdownNickname(player, name) {
    let form1 = new MessageFormData();

    form1.title(" ");
    form1.body(`%fearcube.shop.nickname.reset_color`);
    form1.button1("%gui.no");
    form1.button2("%gui.yes");


    form1.show(player).then(r => {
    if(r.canceled || r.selection == 0){
     return }

     removeTagNickName(player); 
     setLobbyNickname(player);
     runcmd_at(name, `tellraw @s {"rawtext":[{"text":"§a"},{"translate":"fearcube.shop.nickname.standard"}]}`)
     runcmd_at(name, `playsound fall.egg @s ~~~ 1 1`)
     
    
    }).catch((e) => { console.error(e, e.stack); });
}



function removeTagNickName(player) {
    player.removeTag(`nickname:black`);
    player.removeTag(`nickname:dark_blue`);
    player.removeTag(`nickname:dark_green`);
    player.removeTag(`nickname:dark_aqua`);
    player.removeTag(`nickname:dark_red`);
    player.removeTag(`nickname:dark_purple`);
    player.removeTag(`nickname:gold`);
    player.removeTag(`nickname:gray`);
    player.removeTag(`nickname:dark_gray`);
    player.removeTag(`nickname:blue`);
    player.removeTag(`nickname:green`);
    player.removeTag(`nickname:aqua`);
    player.removeTag(`nickname:red`);
    player.removeTag(`nickname:light_purple`);
    player.removeTag(`nickname:yellow`);
    player.removeTag(`nickname:white`);
}

function checkingGoods(items) {
    let item = "";
    let color = "";
    if (items === 1) { item = "color.black"; color = "§0";}
    else if (items === 2) { item = "color.dark_blue"; color = "§1";}
    else if (items === 3) { item = "color.dark_green"; color = `§2`;}
    else if (items === 4) { item = "color.dark_aqua"; color = "§3";}
    else if (items === 5) { item = "color.dark_red"; color = `§4`;}
    else if (items === 6) { item = "color.dark_purple"; color = "§5";}
    else if (items === 7) { item = "color.gold"; color = "§6";}
    else if (items === 8) { item = "color.gray"; color = "§7";}
    else if (items === 9) { item = "color.dark_gray"; color = "§8";}
    else if (items === 10) { item = "color.blue"; color = "§9";}
    else if (items === 11) { item = "color.green"; color = "§a";}
    else if (items === 12) { item = "color.aqua"; color = "§b";}
    else if (items === 13) { item = "color.red"; color = "§c";}
    else if (items === 14) { item = "color.light_purple"; color = "§d";}
    else if (items === 15) { item = "color.yellow"; color = "§e";}
    else if (items === 16) { item = "color.white"; color = "§f";}
    
    
    return { item, color }
}



function SubjectBuy_black(player, money, name, price) {
    let items = 1;
    if (player.hasTag("nickname:black") && player.hasTag("nickname:black_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:black_true") && !player.hasTag("nickname:black")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:black_true") && !player.hasTag("nickname:black")) { 
        SubjectBuy(player, items, name, money, price)}
}


function SubjectBuy_dark_blue(player, money, name, price) {
    let items = 2;
    if (player.hasTag("nickname:dark_blue") && player.hasTag("nickname:dark_blue_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:dark_blue_true") && !player.hasTag("nickname:dark_blue")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:dark_blue_true") && !player.hasTag("nickname:dark_blue")) { 
        SubjectBuy(player, items, name, money, price)}
}


function SubjectBuy_dark_green(player, money, name, price) {
    let items = 3;
    if (player.hasTag("nickname:dark_green") && player.hasTag("nickname:dark_green_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:dark_green_true") && !player.hasTag("nickname:dark_green")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:dark_green_true") && !player.hasTag("nickname:dark_green")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_dark_aqua(player, money, name, price) {
    let items = 4;
    if (player.hasTag("nickname:dark_aqua") && player.hasTag("nickname:dark_aqua_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:dark_aqua_true") && !player.hasTag("nickname:dark_aqua")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:dark_aqua_true") && !player.hasTag("nickname:dark_aqua")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_dark_red(player, money, name, price) {
    let items = 5;
    if (player.hasTag("nickname:dark_red") && player.hasTag("nickname:dark_red_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:dark_red_true") && !player.hasTag("nickname:dark_red")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:dark_red_true") && !player.hasTag("nickname:dark_red")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_dark_purple(player, money, name, price) {
    let items = 6;
    if (player.hasTag("nickname:dark_purple") && player.hasTag("nickname:dark_purple_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:dark_purple_true") && !player.hasTag("nickname:dark_purple")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:dark_purple_true") && !player.hasTag("nickname:dark_purple")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_gold(player, money, name, price) {
    let items = 7;
    if (player.hasTag("nickname:gold") && player.hasTag("nickname:gold_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:gold_true") && !player.hasTag("nickname:gold")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:gold_true") && !player.hasTag("nickname:gold")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_gray(player, money, name, price) {
    let items = 8;
    if (player.hasTag("nickname:gray") && player.hasTag("nickname:gray_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:gray_true") && !player.hasTag("nickname:gray")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:gray_true") && !player.hasTag("nickname:gray")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_dark_gray(player, money, name, price) {
    let items = 9;
    if (player.hasTag("nickname:dark_gray") && player.hasTag("nickname:dark_gray_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:dark_gray_true") && !player.hasTag("nickname:dark_gray")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:dark_gray_true") && !player.hasTag("nickname:dark_gray")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_blue(player, money, name, price) {
    let items = 10;
    if (player.hasTag("nickname:blue") && player.hasTag("nickname:blue_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:blue_true") && !player.hasTag("nickname:blue")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:blue_true") && !player.hasTag("nickname:blue")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_green(player, money, name, price) {
    let items = 11;
    if (player.hasTag("nickname:green") && player.hasTag("nickname:green_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:green_true") && !player.hasTag("nickname:green")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:green_true") && !player.hasTag("nickname:green")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_aqua(player, money, name, price) {
    let items = 12;
    if (player.hasTag("nickname:aqua") && player.hasTag("nickname:aqua_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:aqua_true") && !player.hasTag("nickname:aqua")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:aqua_true") && !player.hasTag("nickname:aqua")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_red(player, money, name, price) {
    let items = 13;
    if (player.hasTag("nickname:red") && player.hasTag("nickname:red_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:red_true") && !player.hasTag("nickname:red")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:red_true") && !player.hasTag("nickname:red")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_light_purple(player, money, name, price) {
    let items = 14;
    if (player.hasTag("nickname:light_purple") && player.hasTag("nickname:light_purple_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:light_purple_true") && !player.hasTag("nickname:light_purple")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:light_purple_true") && !player.hasTag("nickname:light_purple")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_yellow(player, money, name, price) {
    let items = 15;
    if (player.hasTag("nickname:yellow") && player.hasTag("nickname:yellow_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:yellow_true") && !player.hasTag("nickname:yellow")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:yellow_true") && !player.hasTag("nickname:yellow")) { 
        SubjectBuy(player, items, name, money, price)}
}

function SubjectBuy_white(player, money, name, price) {
    let items = 16;
    if (player.hasTag("nickname:white") && player.hasTag("nickname:white_true")) { 
        SubjectShutdownNickname(player, name);}
    if (player.hasTag("nickname:white_true") && !player.hasTag("nickname:white")) { 
        SubjectSelectionNickname(player, items, name, money, price);}
    if (!player.hasTag("nickname:white_true") && !player.hasTag("nickname:white")) { 
        SubjectBuy(player, items, name, money, price)}
}

export { shoopsNickname, SubjectSelectionNickname, SubjectShutdownNickname };