import { world, system } from '@minecraft/server';
import { uiManager } from '@minecraft/server-ui';

export async function runcmd(command, need_log = false){
    try{
        await world.getDimension('overworld').runCommandAsync(command)
    }catch(error){
        if (need_log) {
            console.error(`CMD: ${command}\nError: ${error}`)
        }
    }
}
export async function runcmd_at(name, command, need_log=false){
    if (isNotSelector(name)) {
        await runcmd(`execute as "${name}" at @s run ${command}`,need_log)
    } else {
        await runcmd(`execute as "${name}" at @s run execute as @s at @s run ${command}`, need_log)
    }
}
export function BoolToNum(boolen){
    return boolen == true ? 1 : 0
  }
function isNotSelector (text){
    return text.indexOf('@') == -1
}



export function getScore(objective, target, useZero = false) {
    try {
        const oB = world.scoreboard.getObjective(objective)
        if (typeof target != 'string') { target = target.nameTag }
        return oB.getScore(oB.getParticipants().find(pT => pT.displayName == target))
    } catch {
        return useZero ? 0 : NaN
    }
}


system.afterEvents.scriptEventReceive.subscribe((event) => {
    if (event.id === "fearcube:forms" && event.message === "closeAllForms") {
        let player = event.sourceEntity;
        if (player) { uiManager.closeAllForms(player); }
    }
});

