import { world, system } from "@minecraft/server"



world.afterEvents.entityHurt.subscribe(eventData => {
    const {
        hurtEntity,
        damage,
        damageSource: {
          damagingEntity,
          damagingProjectile,
          cause
        }
      } = eventData
      if (hurtEntity.typeId === "fear:fear_cube" && damagingEntity?.typeId === "minecraft:player") {
        try {
            damagingEntity.runCommandAsync("function other/entity_open_form");
        } catch (error) {
        }
      };


      if (hurtEntity.typeId === "minecraft:player" && damagingProjectile) {
        try {
            damagingEntity.runCommandAsync("playsound random.orb @s ~ ~ ~ 0.5 1");
        } catch (error) {
        }
      };
})


// world.afterEvents.entityDie.subscribe(eventData => {
//     const entity = eventData.deadEntity;
//     const cause = eventData.damageSource;

//     if (entity.typeId === "minecraft:player" && cause?.damagingEntity?.typeId === "minecraft:player") {
//         const killer = cause.damagingEntity;
//         try {
//             killer.runCommandAsync("function other/player_state/kill");
//         } catch (error) {
//             world.sendMessage("Error executing command: " + error);
//         }
//     }
// });


let lastPositions = new Map();

system.afterEvents.scriptEventReceive.subscribe((event) => {
  if (event.id === "fearcube:trigers" && event.message === "On_move") { 
    let player = event.sourceEntity;

    const currentPosition = player.location;
    const lastPosition = lastPositions.get(player.name);

    if (lastPosition) {
        const isMoving = currentPosition.x !== lastPosition.x || currentPosition.y !== lastPosition.y || currentPosition.z !== lastPosition.z;
        if (isMoving) {
            player.addTag("fear:move_on");
        } else {
            player.removeTag("fear:move_on");
        }
    }
    lastPositions.set(player.name, currentPosition);
  }


  if (event.id === "fearcube:trigers" && event.message === "On_shift") { 
    let player = event.sourceEntity;

    if (player.isSneaking) {  // Проверяем, приседает ли игрок
      player.addTag("fear:shift_on");
    } else {
      player.removeTag("fear:shift_on");
    }
  }


});












